.docker-version-script: &docker-version-script
  - |
    echo "== Get image and version =="
    export VERSION_FROM_FILE=$(cat .next-version)
    if [ "$VERSION" != "" ] ; then
      echo "Version variable found ${VERSION}"
    elif [ "$VERSION_FROM_FILE" != "" ] ; then
      echo "Version from file found ${VERSION_FROM_FILE}"
      export VERSION=$VERSION_FROM_FILE
    else
      echo "Use latest as fallback"
      export VERSION=latest
    fi
  - |
    [ -z "$IMAGE" ] && export IMAGE=$CI_REGISTRY_IMAGE && echo "IMAGE variable not set. Use Gitlab project registry."


.docker-login-script: &docker-login-script
  - |
    echo "== Docker Login =="
    [ -z "$IMAGE_REGISTRY" ] && IMAGE_REGISTRY=$CI_REGISTRY && echo "IMAGE_REGISTRY variable not set. Use Gitlab registry."
    [ -z "$IMAGE_REGISTRY_USER" ] && IMAGE_REGISTRY_USER=gitlab-ci-token && echo "IMAGE_REGISTRY_USER variable not set. Use Gitlab default user."
    [ -z "$IMAGE_REGISTRY_PASS" ] && IMAGE_REGISTRY_PASS=$CI_JOB_TOKEN && echo "IMAGE_REGISTRY_PASS variable not set. Use Gitlab CI_JOB_TOKEN."
  - |
    echo "- Registry ${IMAGE_REGISTRY}"
    echo "- User     ${IMAGE_REGISTRY_USER}"
    echo "- Pass     ***MASKED***"
    echo ${IMAGE_REGISTRY_PASS} | docker login --password-stdin --username ${IMAGE_REGISTRY_USER} ${IMAGE_REGISTRY}

.docker-login:
  before_script:
    - *docker-login-script

.docker-build-release:
  image: registry.gitlab.com/leofy.de/docker/gitlab-builder:latest
  services:
    - docker:19.03.0-dind
  stage: docker
  extends:
    - .docker-login
    - .tags-build
    - .rules-only-release
  variables:
    DOCKER_DRIVER: overlay2
    DOCKER_TLS_CERTDIR: "/certs"
    DOCKER_FILE: ./Dockerfile
    #DOCKER_BUILD_CONTEXT: "."
  script:
    - *docker-version-script
    - |
      echo "Build new docker image ${IMAGE}:${VERSION}"
      [ -z "$DOCKER_BUILD_CONTEXT" ] && docker build . -f ${DOCKER_FILE} --tag ${IMAGE}:${VERSION} || docker build -f ${DOCKER_FILE} ${DOCKER_BUILD_CONTEXT} --tag ${IMAGE}:${VERSION}
    - docker push ${IMAGE}:${VERSION}
    - echo ${IMAGE}:${VERSION}
  after_script:
    - docker image prune -a --force --filter "until=240h"
  needs:
    - version:release

.docker-build-mr:
  extends:
    - .docker-build-release
    - .rules-only-mr
  needs:
    - version:mr

.docker-build-dev:
  extends:
    - .docker-build-release
    - .rules-only-master-except-hotfix
  needs:
    - version:master
